//+------------------------------------------------------------------+
//|                                                      Sup_Res.mq4 |
//|                                                            Roger |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Roger"
#property link      ""
//
//---- input parameters
extern double    Lots=0.1;
extern int       Stop=50;
extern int       Take=35;
extern int       Delta=30;
extern bool      TrailingOrder=true; 
extern int       TrailingStop=15; 
extern int       Limit=50; 
double openprice;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
if(ObjectFind("Resistance1")!=-1) ObjectDelete("Resistance1");  
if(ObjectFind("Support1")!=-1) ObjectDelete("Support1");  
if(ObjectFind("Text1")!=-1) ObjectDelete("Text1");  
if(ObjectFind("Text2")!=-1) ObjectDelete("Text2");  
ObjectCreate("Support",OBJ_TREND,0,TimeCurrent()-80*3600,Bid-0.01,TimeCurrent()-20*3600,Bid-0.01);   
ObjectSet("Support",OBJPROP_COLOR,Red);
ObjectCreate("Resistance",OBJ_TREND,0,TimeCurrent()-80*3600,Bid+0.01,TimeCurrent()-20*3600,Bid+0.01);   
ObjectSet("Resistance",OBJPROP_COLOR,Yellow);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
 ObjectDelete("Resistance");  
 ObjectDelete("Support");  
 ObjectDelete("Resistance1");  
 ObjectDelete("Support1");  
 ObjectDelete("Text1");  
 ObjectDelete("Text2");  
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----
   int i,x;
   datetime realtime;
   realtime=Time[0];
   //Comment("Openprice - ",openprice);
   if(OrdersTotal()>0)
      {
      for(i=0;i<OrdersTotal();i++)
         {
         if(TrailingOrder)
            {
            //Print("Price - ",Ask+Delta*Point," Stop - ",Bid+Point*(Delta-Stop)," Take - ",Bid+Point*(Delta+Take));
            OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
            if(OrderSymbol()==Symbol()&&OrderType()==4&&OrderOpenPrice()-Ask>Delta*Point)
            if(!OrderModify(OrderTicket(),Ask+Delta*Point,Bid+Point*(Delta-Stop),Bid+Point*(Delta+Take),0,CLR_NONE))
            Print("ErrorModifyBuyStop - ",GetLastError());
            //Print("Price - ",Bid-Delta*Point," Stop - ",Ask-Point*(Delta-Stop)," Take - ",Ask-Point*(Delta+Take));  
            if(OrderSymbol()==Symbol()&&OrderType()==5&&Bid-OrderOpenPrice()>Delta*Point)
            if(!OrderModify(OrderTicket(),Bid-Delta*Point,Ask-Point*(Delta-Stop),Ask-Point*(Delta+Take),0,CLR_NONE))
            Print("ErrorModifySellStop - ",GetLastError());
            }
         if(TrailingStop>0)
            {
            if(OrderSymbol()==Symbol()&&OrderType()==0&&Bid-OrderOpenPrice()>TrailingStop*Point&&Bid-OrderStopLoss()>TrailingStop*Point)
            if(!OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Point*TrailingStop,OrderTakeProfit(),0,CLR_NONE))
            Print("ErrorModifyBuy - ",GetLastError());            
            if(OrderSymbol()==Symbol()&&OrderType()==1&&OrderOpenPrice()-Ask>TrailingStop*Point&&(OrderStopLoss()-Ask>TrailingStop*Point||OrderStopLoss()==0))
            if(!OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Point*TrailingStop,OrderTakeProfit(),0,CLR_NONE))
            Print("ErrorModifySell - ",GetLastError());            
            }
         if(OrderSymbol()==Symbol())
            {
            x++;
            if(OrderType()<2)openprice=0;
            }
         if(Limit>0&&openprice>0)
            {
            if(OrderSymbol()==Symbol()&&OrderType()==4&&openprice-Ask>Limit*Point)
               {
               if(!OrderDelete(OrderTicket()))Print("ErrorDelete - ",GetLastError());      
               else 
                  {
                  Sleep(5000);
                  RefreshRates();
                  if(OrderSend(Symbol(),OP_SELL,Lots,Bid,6,Ask+Point*Stop,Ask-Point*Take,"",0,0,CLR_NONE)==-1)Print("ErrorSell - ",GetLastError());                  
                  }
               }
            if(OrderSymbol()==Symbol()&&OrderType()==5&&Bid-openprice>Limit*Point)
               {
               if(!OrderDelete(OrderTicket()))Print("ErrorDelete - ",GetLastError());      
               else 
                  {
                  Sleep(5000);
                  RefreshRates();
                  if(OrderSend(Symbol(),OP_BUY,Lots,Ask,6,Bid-Point*Stop,Bid+Point*Take,"",0,0,CLR_NONE)==-1)Print("ErrorBuy - ",GetLastError());                  
                  }
               }
            }
         }
       } 
   if(x==0)
      {
      if(ObjectFind("Resistance")!=-1)
         {
         double resist_price1=ObjectGet("Resistance",OBJPROP_PRICE1);
         double resist_price2=ObjectGet("Resistance",OBJPROP_PRICE2);
         int resist_time1=ObjectGet("Resistance",OBJPROP_TIME1);
         int resist_time2=ObjectGet("Resistance",OBJPROP_TIME2);
         //Print("time - ",resist_time1," ",TimeToStr(resist_time1,TIME_DATE|TIME_MINUTES)," ",resist_time2," ",TimeToStr(resist_time2,TIME_DATE|TIME_MINUTES));
         int resist_bar1=iBarShift(Symbol(),0,resist_time1);
         int resist_bar2=iBarShift(Symbol(),0,resist_time2);
         //Print(resist_bar1," ",resist_bar2);
         double resist_price=resist_price2-(resist_price1-resist_price2)*resist_bar2/(resist_bar1-resist_bar2);
         }
      if(ObjectFind("Support")!=-1)
         {
         double support_price1=ObjectGet("Support",OBJPROP_PRICE1);
         double support_price2=ObjectGet("Support",OBJPROP_PRICE2);
         int support_time1=ObjectGet("Support",OBJPROP_TIME1);
         int support_time2=ObjectGet("Support",OBJPROP_TIME2);
         int support_bar1=iBarShift(Symbol(),0,support_time1);
         int support_bar2=iBarShift(Symbol(),0,support_time2);
         //Print(support_bar1,support_bar2);
         double support_price=support_price2-(support_price1-support_price2)*support_bar2/(support_bar1-support_bar2);
         }
      if(Bid>resist_price&&resist_price>0)
         {
         Print("Price - ",Bid-Delta*Point," Stop - ",Ask-Point*(Delta-Stop)," Take - ",Ask-Point*(Delta+Take));         
         if(OrderSend(Symbol(),OP_SELLSTOP,Lots,Bid-Delta*Point,3,Ask-Point*(Delta-Stop),Ask-Point*(Delta+Take),"",0,0,CLR_NONE)==-1)Print("ErrorSell - ",GetLastError());
         else 
            {
            x=1;openprice=Ask;
            ObjectCreate("Support1",OBJ_TREND,0,support_time1,support_price1,support_time2,support_price2);   
            ObjectSet("Support1",OBJPROP_COLOR,Red);
            ObjectCreate("Resistance1",OBJ_TREND,0,resist_time1,resist_price1,resist_time2,resist_price2);   
            ObjectSet("Resistance1",OBJPROP_COLOR,Yellow);
            ObjectDelete("Resistance");  
            ObjectDelete("Support");              
            ObjectCreate("Text1",OBJ_TEXT,0,support_time2,support_price2);
            ObjectCreate("Text2",OBJ_TEXT,0,resist_time2,resist_price2);
            ObjectSetText("Text1","Old Line!!!",10,"Arial",White);
            ObjectSetText("Text2","Old Line!!!",10,"Arial",White);
            }
         }
      if(Bid<support_price)
         {
         Print("Price - ",Ask+Delta*Point," Stop - ",Bid+Point*(Delta-Stop)," Take - ",Bid+Point*(Delta+Take));
         if(OrderSend(Symbol(),OP_BUYSTOP,Lots,Ask+Delta*Point,3,Bid+Point*(Delta-Stop),Bid+Point*(Delta+Take),"",0,0,CLR_NONE)==-1)Print("ErrorSell - ",GetLastError());
         else 
            {
            x=1;openprice=Bid;
            ObjectCreate("Support1",OBJ_TREND,0,support_time1,support_price1,support_time2,support_price2);   
            ObjectSet("Support1",OBJPROP_COLOR,Red);
            ObjectCreate("Resistance1",OBJ_TREND,0,resist_time1,resist_price1,resist_time2,resist_price1);   
            ObjectSet("Resistance1",OBJPROP_COLOR,Yellow);
            ObjectDelete("Resistance");  
            ObjectDelete("Support");              
            ObjectCreate("Text1",OBJ_TEXT,0,support_time2,support_price2);
            ObjectCreate("Text2",OBJ_TEXT,0,resist_time2,resist_price2);
            ObjectSetText("Text1","Old Line!!!",10,"Arial",White);
            ObjectSetText("Text2","Old Line!!!",10,"Arial",White);
            }
         }
      //Comment("Resist1 - ",resist_price1," Resist2 - ",resist_price2," time - ",resist_time1,"realprice - ",resist_price);
      //Print("Resist1 - ",resist_price1," Resist2 - ",resist_price2," time1 - ",resist_time1," time2 - ",resist_time2," realprice - ",resist_price,
      //" realtime - ",realtime," time1 - ",resist_bar1," time2 - ",resist_bar2," reatime - ",TimeToStr(realtime));
      }     
//----
   return(0);
  }
//+------------------------------------------------------------------+